# $Revision: 1.53 $, $Date: 2004/02/03 14:28:14 $
#
# TODO:
#	- AMD64 port (available patches seem incomplete/buggy)
#
Summary:	Common Language Infrastructure implementation
Summary(pl):	Implementacja Common Language Infrastructure
Name:		mono
Version:	0.30
Release:	1
License:	LGPL
Group:		Development/Languages
Source0:	http://www.go-mono.com/archive/%{name}-%{version}.tar.gz
# Source0-md5:	84bc49f39c905936d594042fd29cd07c
Source1:	http://www.go-mono.com/archive/mcs-%{version}.tar.gz
# Source1-md5:	05152878b29d3e3bfcd1b902cf7e6817
Patch0:		%{name}-alpha.patch
URL:		http://www.go-mono.com/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	glib2-devel
BuildRequires:	libtool
BuildRequires:	pkgconfig
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# workaround for buggy gcc 3.3.1
%define         specflags_alpha "-mno-explicit-relocs"

%description
The Common Language Infrastructure platform. Microsoft has created a
new development platform. The highlights of this new development
platform are:
- A runtime environment that provides garbage collection, threading
  and a virtual machine specification (The Virtual Execution System,
  VES),
- A comprehensive class library,
- A new language, C#. Very similar to Java, C# allows programmers to
  use all the features available on the .NET runtime,
- A language specification that compilers can follow if they want to
  generate classes and code that can interoperate with other programming
  languages (The Common Language Specification: CLS).

%description -l pl
Platforma CLI (Common Language Infrastructure). Microsoft stworzy
now platform developersk. Zalety tej platformy to:
- rodowisko, ktre dostarsza garbage collector, wtki oraz
  specyfikacj maszyny wirtualnej (The Virtual Execution System, VES),
- bibliotek klas,
- nowy jzyk, C#. Bardzo podobny do Javy, C# pozwala programistom na
  uywanie wszystkich moliwoci dostarczanych przez platform .NET,
- specyfikacja dla kompilatorw, ktre chc generowa kod
  wsppracujcy z innymi jzykami programowania (The Common Language
  Specification: CLS).

%package devel
Summary:	Development resources for mono
Summary(pl):	Zasoby programisty do mono
Group:		Development/Libraries
Requires:	%{name} = %{version}

%description devel
Development resources for mono.

%description devel -l pl
Zasoby programisty dla mono.

%package basic
Summary:	MonoBASIC compiler for mono
Summary(pl):	Kompilator MonoBASIC dla mono
Group:		Development/Languages
Requires:	%{name}-devel = %{version}

%description basic
MonoBASIC compiler for mono.

%description basic -l pl
Kompilator MonoBASIC dla mono.

%package csharp
Summary:	C# compiler for mono
Summary(pl):	Kompilator C# dla mono
Group:		Development/Languages
Requires:	%{name}-devel = %{version}

%description csharp
C# compiler for mono.

%description csharp -l pl
Kompilator C# dla mono.

%package ilasm
Summary:	ILasm compiler for mono
Summary(pl):	Kompilator ILasm dla mono
Group:		Development/Languages
Requires:	%{name}-devel = %{version}
Provides:	ilasm
Obsoletes:	pnet-compiler-ilasm

%description ilasm
ILasm compiler for mono.

%description ilasm -l pl
Kompilator ILasm dla mono.

%package static
Summary:	Static mono library
Summary(pl):	Statyczna biblioteka mono
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}

%description static
Static mono library.

%description static -l pl
Statyczna biblioteka mono.

%package jay
Summary:	Yacc-like parser generator for Java and C#
Summary(pl):	Podobny do Yacca generator parserw dla Javy i C#
Group:		Development/Tools

%description jay
Yacc-like parser generator for Java and C#.

%description jay -l pl
Podobny do Yacca generator parserw dla Javy i C#.

%prep
%setup -q -a1
%patch0 -p1

%build
rm -f missing
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
	--with-gc=included

%{__make}

# for now we only build jay, and don't rebuild runtime and mcs
%{__make} -C mcs-%{version}/jay \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -DSKEL_DIRECTORY=\\\"%{_datadir}/jay\\\""

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__make} -C mcs-%{version}/jay install \
	prefix=%{_prefix} \
	DESTDIR=$RPM_BUILD_ROOT
mv -f $RPM_BUILD_ROOT%{_prefix}/man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1
rm -f $RPM_BUILD_ROOT%{_datadir}/jay/[A-Z]*

%ifnarch %{ix86}
ln -s mint $RPM_BUILD_ROOT%{_bindir}/mono
%endif

# Make links to all binaries. In fact we could move *.exe to
# %{_libdir}, but probably something relays on it.
old="$(pwd)"
cd $RPM_BUILD_ROOT%{_bindir}
for f in *.exe ; do
	bn=$(basename $f .exe)
	rm -f $bn
	echo "#!/bin/sh" > $bn
	echo "%{_bindir}/mono %{_bindir}/$f" '"$@"' >> $bn
done
cd "$old"


# this way we can run rpmbuild -bi several times, and directories
# have more meaningful name.
rm -rf pld-doc
mkdir -p pld-doc/{webpage,notes}
cp -a doc/* pld-doc/webpage/
cp -a docs/* pld-doc/notes/
rm -f pld-doc/*/Makefile*

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/mint
%attr(755,root,root) %{_bindir}/mono
%attr(755,root,root) %{_bindir}/secutil*
%attr(755,root,root) %{_bindir}/chktrust*
%attr(755,root,root) %{_bindir}/signcode*
%attr(755,root,root) %{_bindir}/sn
%attr(755,root,root) %{_bindir}/monosn
%ifarch %{ix86}
#%attr(755,root,root) %{_bindir}/oldmono
%attr(755,root,root) %{_libdir}/lib*.so.*.*
%endif
%attr(755,root,root) %{_libdir}/*.dll
%{_mandir}/man5/mono-config.5*
%{_mandir}/man1/mint.1*
%{_mandir}/man1/mono.1*
#%{_mandir}/man1/oldmono.1*
%dir %{_sysconfdir}/mono
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mono/config
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mono/machine.config
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mono/browscap.ini
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mono/DefaultWsdlHelpGenerator.aspx

%files jay
%defattr(644,root,root,755)
%doc mcs-%{version}/jay/{ACKNOWLEDGEMENTS,ChangeLog,NEW_FEATURES,NOTES,README,README.jay}
%attr(755,root,root) %{_bindir}/jay
%dir %{_datadir}/jay
%{_datadir}/jay/skeleton*
%{_mandir}/man1/jay.1*

%files devel
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS README pld-doc/*
%attr(755,root,root) %{_bindir}/monodis
%attr(755,root,root) %{_bindir}/xsd*
%attr(755,root,root) %{_bindir}/monograph
%attr(755,root,root) %{_bindir}/monoresgen*
%attr(755,root,root) %{_bindir}/pedump
%attr(755,root,root) %{_bindir}/wsdl*
%attr(755,root,root) %{_bindir}/genxs*
%attr(755,root,root) %{_bindir}/sqlsharp*
%attr(755,root,root) %{_bindir}/disco*
%attr(755,root,root) %{_bindir}/cilc*
%attr(755,root,root) %{_bindir}/al*
%attr(755,root,root) %{_bindir}/soapsuds*
%ifarch %{ix86}
%{_libdir}/lib*.la
%attr(755,root,root) %{_libdir}/lib*.so
%endif
%{_datadir}/%{name}
%{_pkgconfigdir}/*.pc
%{_includedir}/%{name}
%{_mandir}/man1/cilc.1*
%{_mandir}/man1/genxs.1*
%{_mandir}/man1/monoburg.1*
%{_mandir}/man1/monodis.1*
%{_mandir}/man1/monostyle.1*
%{_mandir}/man1/sqlsharp.1*
%{_mandir}/man1/cert2spc.1*
%{_mandir}/man1/wsdl.1*
%{_mandir}/man1/soapsuds.1*
%{_mandir}/man1/disco.1*

%files csharp
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/mcs*
%{_mandir}/man1/mcs.1*

%files basic
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/mbas*

%files ilasm
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ilasm*
%{_mandir}/man1/ilasm.1*

%ifarch %{ix86}
%files static
%defattr(644,root,root,755)
%{_libdir}/lib*.a
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mono.spec,v $
Revision 1.53  2004/02/03 14:28:14  grzegol
- updated to 0.30

Revision 1.52  2004/01/27 09:28:06  jajcus
- no AMD64 patch yet :-(

Revision 1.51  2004/01/25 14:06:57  krzak
- copy config.sub from automake

Revision 1.50  2003/12/03 15:10:24  malekith
- up to 0.29
- TODO: package and link http://oss.software.ibm.com/icu/index.html
- didn't do much testing, but at least it can bootstrap my compiler ;-)

Revision 1.49  2003/10/16 11:53:33  wiget
- correct arch_target on alpha

Revision 1.48  2003/10/16 11:20:01  wiget
- don't overide users CFLAGS

Revision 1.47  2003/10/16 10:05:47  wiget
- workaround to buggy 3.3.1 on alpha

Revision 1.46  2003/10/16 08:45:04  tiwek
- release up

Revision 1.45  2003/10/16 08:43:29  tiwek
- added patch to compile on sparc architecture ?

Revision 1.44  2003/10/02 22:09:39  malekith
- added missing files from 0.28
- seems to work

Revision 1.43  2003/10/02 21:17:30  malekith
- started updated to 0.28

Revision 1.42  2003/09/14 16:59:33  malekith
- switch to included libgc (it's patched) -- it's needed for
  mono debugger
- release 4

Revision 1.41  2003/09/09 09:54:13  malekith
- split jay into subpackage
- add missing skeleton and docs for jay
- release 3

Revision 1.40  2003/09/07 19:33:58  undefine
- mono-compiler doesn't require ilasm

Revision 1.39  2003/09/07 19:06:42  undefine
- Requires: ilasm for cscc compiler (what is compiler without assembler? ;)

Revision 1.38  2003/09/07 19:05:43  undefine
- provides: ilasm for mono-ilasm package
- obsoletes pnet-compiler-ilasm for mono-ilasm
- release 2

Revision 1.37  2003/08/18 08:08:21  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.36  2003/08/15 15:23:31  malekith
- up to 0.26

Revision 1.35  2003/06/30 15:04:18  qboosh
- added nolibs patch to remove -lnsl -lrt
- oldmono disappeared, genmdesc is noinst now
- builds now - release 1.1

Revision 1.34  2003/06/26 20:49:09  jareq
- up to 0.25

Revision 1.33  2003/05/25 11:00:55  malekith
- massive attack, adding Source-md5

Revision 1.32  2003/05/25 05:50:44  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.31  2003/05/14 18:03:51  undefine
- add BR: flex

Revision 1.30  2003/05/08 08:38:19  malekith
- fixed files on non-x86 (ppc jit is not there yet)

Revision 1.29  2003/05/07 20:49:31  malekith
- up to 0.24

Revision 1.28  2003/03/12 10:23:00  malekith
- fix build: mcs-%%{version} not mcs

Revision 1.27  2003/03/12 09:09:20  malekith
- up to 0.23

Revision 1.26  2003/03/06 10:01:46  trojan
- updated to 0.22

Revision 1.25  2003/03/02 18:21:45  radek
- random summary/description fixes

Revision 1.24  2003/03/02 17:08:34  malekith
- up to 0.21

Revision 1.23  2003/02/27 10:23:31  qboosh
- added defattr (really needed in one place)

Revision 1.22  2003/02/26 21:31:12  malekith
- added mcs source tarball, but only build jay from it, nothing else (at
  least for now)
- release 2

Revision 1.21  2003/02/26 16:39:13  malekith
- updated to 0.20
- compilers (C#, Basic and ILasm) moved to subpackages
- unpackaged files added

Revision 1.20  2003/02/15 09:02:22  trojan
- updated to 0.19

Revision 1.19  2002/11/28 17:16:40  djurban
- Updated to 0.16 (Req. by kdebindings)

Revision 1.18  2002/11/25 14:17:43  ankry
- massive attack: no need for 755 for *.la

Revision 1.17  2002/10/09 13:14:40  kloczek
- use more macros, some cosmetics, added missing "rm -f missing" and use new %doc

Revision 1.16  2002/09/05 12:03:45  qboosh
- fixed compilation with NO_PORT (currently on alpha)
- added mono/config file, release 4

Revision 1.15  2002/08/29 18:30:23  marcus
- fixed %%files on ix86
- rel.3.

Revision 1.14  2002/08/26 08:05:52  kloczek
- adapterized.

Revision 1.13  2002/08/26 07:50:44  marcus
- urgh... rel.2. (kloczek tagged nfy rel.1.)
- fixes for !ix86

Revision 1.12  2002/08/25 21:18:38  marcus
- updated to 0.15

Revision 1.11  2002/08/14 11:37:41  malekith
- cleanup: removed obsolete patches

Revision 1.10  2002/08/14 11:30:55  malekith
- up to 0.13

Revision 1.9  2002/06/23 20:32:32  kloczek
- perl -pi -e "s/^libtoolize --copy --force/\%\{__libtoolize\}/"

Revision 1.8  2002/05/21 23:14:09  kloczek
perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
             s/^automake -a -c -f/\%\{__automake\}/; \
	     s/^autoconf/\%\{__autoconf\}/"

Revision 1.7  2002/03/24 23:28:22  kloczek
- perl -pi -e "s/^automake -a -c$/automake -a -c -f/"

Revision 1.6  2002/02/22 23:29:17  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.5  2002/01/18 02:13:54  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.4  2001/12/14 12:39:47  kloczek
- release 2.

Revision 1.3  2001/12/14 09:50:58  qboosh
- cosmetics

Revision 1.2  2001/12/13 18:18:06  kloczek
- added devel and static subpackages,
- added regenerate ac/am/lt files (added DESTDIR ad ac_fixes patches).

Revision 1.1  2001/12/13 13:44:30  misiek
- initial PLD release
